//    This file is part of Motion Watch.

//    Motion Watch is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    Motion Watch is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "logger.h"

void wrLogLine(const QString &line, shared_t *share, QString &body)
{
    if (!line.isEmpty())
    {
        share->logMutex.lock();

        body += QDateTime::currentDateTime().toString("[yyyy-MM-dd-hh-mm-ss] ") + line + "\n";

        share->logMutex.unlock();
    }
}

void recLog(const QString &line, shared_t *share)
{
    wrLogLine(line, share, share->recLog);
}

void detLog(const QString &line, shared_t *share)
{
    wrLogLine(line, share, share->detLog);
}

void enforceMaxLogSize(const QString &filePath, shared_t *share)
{
    QFile file(filePath);

    if (file.exists())
    {
        if (file.size() >= share->maxLogSize)
        {
            file.remove();
        }
    }
}

void dumpLogs(const QString &fileName, const QString &lines)
{
    if (!lines.isEmpty())
    {
        QFile outFile(fileName);

        if (outFile.exists())
        {
            outFile.open(QFile::Append);
        }
        else
        {
            outFile.open(QFile::WriteOnly);
        }

        outFile.write(lines.toUtf8());
        outFile.close();
    }
}
